function y=calculation
angle=0.1;
extent0=2;
press=0.1;
voltage=0;
R0=1;

L0=2;
z0=0;%initial height
z1=L0/R0;% the length of the tube
steplength=0.01;% integrated step size
angle0=angle;% the tagent angle at the boundary
options=odeset('RelTol',1e-8,'AbsTol',[1e-8 1e-8 1e-8 1e-8]);
[XX1,YY2]=ode45(@tubetest,[z0:steplength:z1],[1 angle0 extent0 0],options,press,voltage);

% in the second  square brackets, they are initia conditions, r0, angle0,
% and the stretch ratio at the left end, the last one is for the component
% of the cordinates z.

y=YY2(end,:);
y(1)=y(1)-1;%ҪעС1
plot(XX1,YY2(:,1))% z, r
 
 function dy=tubetest(yita,y,press,voltage)
volt=voltage;
jlim=220;
dy=[0;0;0;0];
%jlimʱj11s1s2neohookenģͣ
j1=1-(y(3)^2+1/(y(1)^2*y(3)^2)+y(1)^2-3)/jlim;
s1=-volt^2*y(1)^2*y(3) + (-(1/(y(1)^2*y(3)^2)) + y(3)^2)/(y(3)*j1);%s1
s2=-volt^2*y(1)*y(3)^2 + (y(1)^2 - 1/(y(1)^2*y(3)^2))/(y(1)*j1);%S2
%%%%%%%%%%%%%%%%һǹlmda1΢ֱʽ%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
coef1=((2/(j1*y(1)^3*y(3)^2)-2*volt^2*y(3)^2*y(1)+2*(1/(y(3)^4*y(1)^5)-1/y(1)^3-1/(y(3)^2*y(1))+(y(3)^2*y(1)))/(j1^2*jlim))-s2)*sin(y(2));
coef2=-(1/j1-volt^2*y(1)^2+2/(j1^2*jlim*y(1)^4*y(3)^6)+3/(j1*y(1)^2*y(3)^4)-4/(j1^2*jlim*y(1)^2*y(3)^2)+(2*y(3)^2)/(j1^2*jlim));%lmdaķĸ
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
dy(1)=y(3)*sin(y(2));%dr/dR
if abs(s2)<10^-16
    if press==0
        dy(2)=0;
    else
    dy(2)=-y(3)*y(1)*press/s1;
    end
 else
dy(2)=s2*cos(y(2))/s1-y(3)*y(1)*press/s1;%d theta/dR
end
dy(3)=coef1/coef2;%d lambda/dR
dy(4)=y(3)*cos(y(2));%dz /dR